//+------------------------------------------------------------------+
//|														     		  	 ScreenPost |
//|											Copyright  2011 www.fxmaster.de |
//|			   	      						  Coding by Sergeev Alexey |
//+------------------------------------------------------------------+
#property copyright "www.fxmaster.de  2006-2011"
#property link "www.fxmaster.de"
#property version "1.00"
#property description "Post screenshot to your server"

#include <InternetLib.mqh>

MqlNet INet; // instance the class for working

//------------------------------------------------------------------ OnStart
void OnStart()
{
	// open session
	if (!INet.Open("www.fxmaster.de", 80, "", "", INTERNET_SERVICE_HTTP)) return;

	string giffile=Symbol()+"_"+TimeToString(TimeCurrent())+".gif"; // name of the file to be sent
	
	// create a 800*600 px screenshot
	if (!ChartScreenShot(0, giffile, 800, 600)) { Print("-err ScreenShot "); return; } 
	
	// read the gif-file to the array
	int h=FileOpen(giffile, FILE_ANSI|FILE_BIN|FILE_READ); if (h<0) { Print("-err Open gif-file "+giffile); return; }
	FileSeek(h, 0, SEEK_SET);
	ulong n=FileSize(h); // determine the file size
	uchar gif[]; ArrayResize(gif, (int)n); // create a uichar array according to the size of data
	FileReadArray(h, gif); // read the file to the array
	FileClose(h); // close the file
	
	// create the file to be sent
	string sendfile="sendfile.txt";
	h=FileOpen(sendfile, FILE_ANSI|FILE_BIN|FILE_WRITE); if (h<0) { Print("-err Open send-file "+sendfile); return; }
	FileSeek(h, 0, SEEK_SET);

	// form the request
	string bound="++1BEF0A57BE110FD467A++"; // data separator for the request
	string Head="Content-Type: multipart/form-data; boundary="+bound+"\r\n"; // header
	string Path="/mt5screen/screen.php"; // path to the page
	
	// write data
	FileWriteString(h, "\r\n--"+bound+"\r\n");
	FileWriteString(h, "Content-Disposition: form-data; name=\"EA\"\r\n");
	FileWriteString(h, "\r\n");
	FileWriteString(h, "NAME_EA");
	FileWriteString(h, "\r\n--"+bound+"\r\n");
	FileWriteString(h, "Content-Disposition: form-data; name=\"data\"; filename=\""+giffile+"\"\r\n");
	FileWriteString(h, "Content-Type: image/gif\r\n");
	FileWriteString(h, "Content-Transfer-Encoding: binary\r\n");
	FileWriteString(h, "\r\n");
	FileWriteArray(h, gif); // write gif-information
	FileWriteString(h, "\r\n--"+bound+"--\r\n");
	FileClose(h); // close the file

	tagRequest req; // initialization of parameters 
	req.Init("POST", Path, Head, sendfile, true, "answer.htm", true);
	
	if (INet.Request(req)) Print("-err Request"); // send the request to the server
	else Print("+ok Request"); 
}